LayoutVersion.Feature (Apache Hadoop HDFS 3.5.0 API)
Description: declaration: package: org.apache.hadoop.hdfs.protocol, class: LayoutVersion, enum: Feature

Package org.apache.hadoop.hdfs.protocol

# Enum Class LayoutVersion.Feature

java.lang.Object
java.lang.Enum<LayoutVersion.Feature>
org.apache.hadoop.hdfs.protocol.LayoutVersion.Feature

All Implemented Interfaces:
  `Serializable`, `Comparable<LayoutVersion.Feature>`, `Constable`, `LayoutVersion.LayoutFeature`

Enclosing class:
  LayoutVersion

public static enum LayoutVersion.Feature extends Enum<LayoutVersion.Feature> implements LayoutVersion.LayoutFeature
Enums for features that change the layout version before rolling upgrade is supported.
To add a new layout version:

- Define a new enum constant with a short enum name, the new layout version and description of the added feature.
- When adding a layout version with an ancestor that is not same as its immediate predecessor, use the constructor where a specific ancestor can be passed.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `ADD_DATANODE_AND_STORAGE_UUIDS`
  `ADD_INODE_ID`
  `ADD_LAYOUT_FLAGS`
  `APPEND_RBW_DIR`
  `ATOMIC_RENAME`
  `CACHING`
  `CONCAT`
  `DELEGATION_TOKEN`
  `DISKSPACE_QUOTA`
  `EDITLOG_ADD_BLOCK`
  `EDITLOG_OP_OPTIMIZATION`
  `EDITLOG_SUPPORT_RETRYCACHE`
  `EDITS_CHECKSUM`
  `EXTENDED_ACL`
  `FEDERATION`
  `FILE_ACCESS_TIME`
  `FSIMAGE_CHECKSUM`
  `FSIMAGE_COMPRESSION`
  `FSIMAGE_NAME_OPTIMIZATION`
  `LEASE_REASSIGNMENT`
  `NAMESPACE_QUOTA`
  `OPTIMIZE_PERSIST_BLOCKS`
  `OPTIMIZE_SNAPSHOT_INODES`
  `PROTOBUF_FORMAT`
  `REMOVE_REL13_DISK_LAYOUT_SUPPORT`
  `RESERVED_REL1_2_0`
  `RESERVED_REL1_3_0`
  `RESERVED_REL2_4_0`
  `RESERVED_REL20_203`
  `RESERVED_REL20_204`
  `RESERVED_REL22`
  `RESERVED_REL23`
  `SEQUENTIAL_BLOCK_ID`
  `SNAPSHOT`
  `STICKY_BIT`
  `STORED_TXIDS`
  `SYMLINKS`
  `TXID_BASED_LAYOUT`
  `UNUSED`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `LayoutVersion.FeatureInfo`
  `getInfo()`
  `static LayoutVersion.Feature`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static LayoutVersion.Feature[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### NAMESPACE_QUOTA

    public static final LayoutVersion.Feature NAMESPACE_QUOTA

  - ### FILE_ACCESS_TIME

    public static final LayoutVersion.Feature FILE_ACCESS_TIME

  - ### DISKSPACE_QUOTA

    public static final LayoutVersion.Feature DISKSPACE_QUOTA

  - ### STICKY_BIT

    public static final LayoutVersion.Feature STICKY_BIT

  - ### APPEND_RBW_DIR

    public static final LayoutVersion.Feature APPEND_RBW_DIR

  - ### ATOMIC_RENAME

    public static final LayoutVersion.Feature ATOMIC_RENAME

  - ### CONCAT

    public static final LayoutVersion.Feature CONCAT

  - ### SYMLINKS

    public static final LayoutVersion.Feature SYMLINKS

  - ### DELEGATION_TOKEN

    public static final LayoutVersion.Feature DELEGATION_TOKEN

  - ### FSIMAGE_COMPRESSION

    public static final LayoutVersion.Feature FSIMAGE_COMPRESSION

  - ### FSIMAGE_CHECKSUM

    public static final LayoutVersion.Feature FSIMAGE_CHECKSUM

  - ### REMOVE_REL13_DISK_LAYOUT_SUPPORT

    public static final LayoutVersion.Feature REMOVE_REL13_DISK_LAYOUT_SUPPORT

  - ### EDITS_CHECKSUM

    public static final LayoutVersion.Feature EDITS_CHECKSUM

  - ### UNUSED

    public static final LayoutVersion.Feature UNUSED

  - ### FSIMAGE_NAME_OPTIMIZATION

    public static final LayoutVersion.Feature FSIMAGE_NAME_OPTIMIZATION

  - ### RESERVED_REL20_203

    public static final LayoutVersion.Feature RESERVED_REL20_203

  - ### RESERVED_REL20_204

    public static final LayoutVersion.Feature RESERVED_REL20_204

  - ### RESERVED_REL22

    public static final LayoutVersion.Feature RESERVED_REL22

  - ### RESERVED_REL23

    public static final LayoutVersion.Feature RESERVED_REL23

  - ### FEDERATION

    public static final LayoutVersion.Feature FEDERATION

  - ### LEASE_REASSIGNMENT

    public static final LayoutVersion.Feature LEASE_REASSIGNMENT

  - ### STORED_TXIDS

    public static final LayoutVersion.Feature STORED_TXIDS

  - ### TXID_BASED_LAYOUT

    public static final LayoutVersion.Feature TXID_BASED_LAYOUT

  - ### EDITLOG_OP_OPTIMIZATION

    public static final LayoutVersion.Feature EDITLOG_OP_OPTIMIZATION

  - ### OPTIMIZE_PERSIST_BLOCKS

    public static final LayoutVersion.Feature OPTIMIZE_PERSIST_BLOCKS

  - ### RESERVED_REL1_2_0

    public static final LayoutVersion.Feature RESERVED_REL1_2_0

  - ### ADD_INODE_ID

    public static final LayoutVersion.Feature ADD_INODE_ID

  - ### SNAPSHOT

    public static final LayoutVersion.Feature SNAPSHOT

  - ### RESERVED_REL1_3_0

    public static final LayoutVersion.Feature RESERVED_REL1_3_0

  - ### OPTIMIZE_SNAPSHOT_INODES

    public static final LayoutVersion.Feature OPTIMIZE_SNAPSHOT_INODES

  - ### SEQUENTIAL_BLOCK_ID

    public static final LayoutVersion.Feature SEQUENTIAL_BLOCK_ID

  - ### EDITLOG_SUPPORT_RETRYCACHE

    public static final LayoutVersion.Feature EDITLOG_SUPPORT_RETRYCACHE

  - ### EDITLOG_ADD_BLOCK

    public static final LayoutVersion.Feature EDITLOG_ADD_BLOCK

  - ### ADD_DATANODE_AND_STORAGE_UUIDS

    public static final LayoutVersion.Feature ADD_DATANODE_AND_STORAGE_UUIDS

  - ### ADD_LAYOUT_FLAGS

    public static final LayoutVersion.Feature ADD_LAYOUT_FLAGS

  - ### CACHING

    public static final LayoutVersion.Feature CACHING

  - ### PROTOBUF_FORMAT

    public static final LayoutVersion.Feature PROTOBUF_FORMAT

  - ### EXTENDED_ACL

    public static final LayoutVersion.Feature EXTENDED_ACL

  - ### RESERVED_REL2_4_0

    public static final LayoutVersion.Feature RESERVED_REL2_4_0

- ## Method Details

  - ### values

    public static LayoutVersion.Feature[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static LayoutVersion.Feature valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### getInfo

    public LayoutVersion.FeatureInfo getInfo()
    Specified by:
      `getInfo` in interface `LayoutVersion.LayoutFeature`